'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _reactNative = require('react-native');

var _reactNative2 = _interopRequireDefault(_reactNative);

var _util = require('./util');

var _style = require('./theme/style');

var _style2 = _interopRequireDefault(_style);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Icon = require('react-native-vector-icons/FontAwesome');

var LILoginMock = function (_Component) {
  _inherits(LILoginMock, _Component);

  function LILoginMock(props) {
    _classCallCheck(this, LILoginMock);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(LILoginMock).call(this, props));

    _this.willUnmountSoon = false;

    _this.state = {
      credentials: null,
      subscriptions: []
    };
    return _this;
  }

  _createClass(LILoginMock, [{
    key: 'handleLogin',
    value: function handleLogin() {
      var _this2 = this;

      (0, _util.login)(this.props.appDetails).then(function (data) {
        if (!_this2.willUnmountSoon) _this2.setState({ credentials: data });
      })["catch"](function (err) {
        if (!_this2.willUnmountSoon) _this2.setState({ credentials: null });
      });
    }
  }, {
    key: 'handleLogout',
    value: function handleLogout() {
      var _this3 = this;

      (0, _util.logout)().then(function (data) {
        if (!_this3.willUnmountSoon) _this3.setState({ credentials: null });
      })["catch"](function (err) {
        console.warn(err);
      });
    }
  }, {
    key: 'onPress',
    value: function onPress() {
      this.state.credentials ? this.handleLogout() : this.handleLogin();

      this.props.onPress && this.props.onPress();
    }
  }, {
    key: 'invokeHandler',
    value: function invokeHandler(eventType, eventData) {
      var eventHandler = this.props["on" + eventType];
      if (typeof eventHandler === 'function') eventHandler(eventData);
    }
  }, {
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _this4 = this;

      this.willUnmountSoon = false;

      var subscriptions = this.state.subscriptions;
      Object.keys(_util.liEvents).forEach(function (eventType) {
        var sub = _reactNative.DeviceEventEmitter.addListener(_util.liEvents[eventType], _this4.invokeHandler.bind(_this4, eventType));
        subscriptions.push(sub);
      });

      // Add listeners to state
      this.setState({ subscriptions: subscriptions });
    }
  }, {
    key: 'unSubscribeEvents',
    value: function unSubscribeEvents(subscription) {
      subscription.remove();
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.willUnmountSoon = true;
      this.state.subscriptions.forEach(this.unSubscribeEvents);
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this5 = this;

      (0, _util.getCredentials)().then(function (data) {
        _this5.setState({ credentials: data });
      })["catch"](function (err) {
        _this5.setState({ credentials: null });
        console.log('Request failed: ', err);
      });
    }
  }, {
    key: 'prepareStyle',
    value: function prepareStyle() {
      var _props$style = this.props.style;
      var style = _props$style === undefined ? {} : _props$style;

      var LILMText = style.LILMText || _style2["default"].LILMText;
      var LILMTextLoggedIn = style.LILMTextLoggedIn || _style2["default"].LILMTextLoggedIn;
      var LILMTextLoggedOut = style.LILMTextLoggedOut || _style2["default"].LILMTextLoggedOut;

      return {
        LILMButton: style.LILMButton || _style2["default"].LILMButton,
        LILMButtonContent: style.LILMButtonContent || _style2["default"].LILMButtonContent,
        LILMIconWrap: style.LILMIconWrap || _style2["default"].LILMIconWrap,
        LILMIcon: style.LILMIcon || _style2["default"].LILMIcon,
        LILMTextWrap: style.LILMTextWrap || _style2["default"].LILMTextWrap,
        LILMText: [LILMText, this.state.credentials ? LILMTextLoggedIn : LILMTextLoggedOut]
      };
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var _props$loginText = _props.loginText;
      var loginText = _props$loginText === undefined ? "Log in with Linkedin" : _props$loginText;
      var _props$logoutText = _props.logoutText;
      var logoutText = _props$logoutText === undefined ? "Log out" : _props$logoutText;

      var text = this.state.credentials ? logoutText : loginText;

      var _prepareStyle = this.prepareStyle();

      var LILMButton = _prepareStyle.LILMButton;
      var LILMButtonContent = _prepareStyle.LILMButtonContent;
      var LILMIconWrap = _prepareStyle.LILMIconWrap;
      var LILMIcon = _prepareStyle.LILMIcon;
      var LILMTextWrap = _prepareStyle.LILMTextWrap;
      var LILMText = _prepareStyle.LILMText;

      return _reactNative2["default"].createElement(
        _reactNative.TouchableHighlight,
        { style: LILMButton, onPress: this.onPress.bind(this) },
        _reactNative2["default"].createElement(
          _reactNative.View,
          { style: LILMButtonContent },
          _reactNative2["default"].createElement(
            _reactNative.View,
            { style: LILMIconWrap },
            _reactNative2["default"].createElement(Icon, { name: 'linkedin', style: LILMIcon })
          ),
          _reactNative2["default"].createElement(
            _reactNative.View,
            { style: LILMTextWrap },
            _reactNative2["default"].createElement(
              _reactNative.Text,
              { style: LILMText, numberOfLines: 1 },
              text
            )
          ),
          _reactNative2["default"].createElement(_reactNative.View, { style: LILMIconWrap })
        )
      );
    }
  }]);

  return LILoginMock;
}(_reactNative.Component);

/**
 *
 *  appDetails: {
 *    redirectUrl, // optional
 *    clientId, // client id
 *    clientSecret, // client secret
 *    state, // some unique string that is hard to guess
 *    scopes // an array of permissions / scores your app will request access to.
 *  }
 *
 */


exports["default"] = LILoginMock;
LILoginMock.propTypes = {
  styleOverride: _reactNative.PropTypes.object,
  appDetails: _reactNative.PropTypes.object,
  loginText: _reactNative.PropTypes.string,
  logoutText: _reactNative.PropTypes.string,
  onPress: _reactNative.PropTypes.func,
  onLogin: _reactNative.PropTypes.func,
  onLoginError: _reactNative.PropTypes.func,
  onRequestSucess: _reactNative.PropTypes.func,
  onRequestError: _reactNative.PropTypes.func
};