'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.login = exports.getProfileImages = exports.getCredentials = exports.logout = exports.liEvents = undefined;

var login = exports.login = function () {
  var ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(_ref) {
    var clientId = _ref.clientId;
    var redirectUrl = _ref.redirectUrl;
    var clientSecret = _ref.clientSecret;
    var state = _ref.state;
    var scopes = _ref.scopes;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (!(!clientId || !redirectUrl || !clientSecret || !state)) {
              _context.next = 2;
              break;
            }

            throw new Error(REQUIRED_FIELD_MISSING);

          case 2:
            _context.next = 4;
            return loginAsync(clientId, redirectUrl, clientSecret, state, scopes);

          case 4:
            return _context.abrupt('return', _context.sent);

          case 5:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function login(_x) {
    return ref.apply(this, arguments);
  };
}();

var _reactNative = require('react-native');

var _reactNative2 = _interopRequireDefault(_reactNative);

var _tinyPromisify = require('tiny-promisify');

var _tinyPromisify2 = _interopRequireDefault(_tinyPromisify);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

var LinkedinLogin = _reactNative.NativeModules.LinkedinLogin;


var REQUIRED_FIELD_MISSING = 'A required field is missing.';

var liEvents = exports.liEvents = {
  Login: 'linkedinLogin',
  LoginError: 'linkedinLoginError',
  RequestSucess: 'linkedinGetRequest',
  RequestError: 'linkedinGetRequestError'
};

var logout = exports.logout = (0, _tinyPromisify2["default"])(LinkedinLogin.logout);
var getCredentials = exports.getCredentials = (0, _tinyPromisify2["default"])(LinkedinLogin.getCredentials);
var getProfileImages = exports.getProfileImages = (0, _tinyPromisify2["default"])(LinkedinLogin.getProfileImages);
var loginAsync = (0, _tinyPromisify2["default"])(LinkedinLogin.login);